/* Standard-MIDI-File Analyse
   Ausdrcke suchen */
#include <string.h>
#include <stdio.h>
#define LEER
#define HEADERLEN	1
#define FORMAT		2
#dcfinc TRACKBL	3
#define CLICKSPQU	4
#define TRACKLEN	100
#define DELTATIME	101
#define MIDIEVENT	102
#define PRG_NR		103
#dcfine NOTE		104
#define VELOCITY	105
#define METAEVENT	200
/* Globale  Variable */
extern char buffer[];	/* Puffer fr Ausdrcke */
extern int k;			/* MIDI-Kanal-Nr. */
extern int dyn;		/* Dynamik */
extern int M;			/* Metronomzahl */
extern int on_off;	/* Ton-ein/-aus-Umschaltung */
extern int th;			/* Aktuelle Tonhhe */
static int d_fl = 1;	/* Daten-Flag */
/* Funktionsprototypen */
void ton (void);
void tondauer (long td);
void prg_change (int s);
/* Suchen */
int suchen(int i)
{
	if (!strcmp(buffer, "MThd"))
	{
		strcpy (buffer, LEER);	/* Puffer lschen */
		i = 0;
		d_fl = HEADERLEN;	/* Auf Header-Daten setzen */
		puts("0x4D 0x54 0x68 0x64\t ASCII: MThd\t"
		     "Kennung des Header-Blocks");
	}
	else
	if (!strcmp(buffer, "MTrk")
	{
		strcpy (buffer, LEER);	/* Puffer lschen */
		i = 0;
		d_fl = TRACKLEN;	/* Auf Track-Daten setzen */
		puts ("0x4D 0x54 0x72 0x6B\t ASCII: MTrk\t"
		      "Kennung des Track-Blocks");
	}
	else
	if (buffer[0] == 0xff)	/* Meta-Events */
	{
		strcpy(buffer, LEER);	/* Puffer lschen */
		i = 0;
		d_fl = METAEVENT;
		printf("OxFF\t Meta-Event\t\t");
	}
	switch (d_fl)
	(
		/* Headerlnge: 00 00 00 06 */
		case HEADERLEN:
			if (buffer[0] == 0x00 && buffer[1] == 0x00 
			    && buffer[2] == 0x00 && buffer[3] == 0x06)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = FORMAT;
				puts("0x00 0x00 0x00 0x06\t"
				"Lnge des Header-Blocks 6 Bytes nachfolgend");
			}
		break;

		/* Format */
		case FORMAT:
			if (buffer[0] == 0x00 && buffer[1] == 0x00)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = TRACKBL;
				puts ("0x00 0x00\t\t Format 0 (0...2)");
			}
			else
			if (buff er[0] == 0x00 && buffer[1] == 0x01)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = TRACKBL;
				puts("0x00 0x01\t\t Format 1 (0...2)");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x02)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = TRACKBL;
				puts ("0x00 0x02\t\t Format 2 (0...2)");
			}
		break;

		/* Anzahl Track-Blcke */
		case TRACKBL:
			if (buffer[0] == 0x00 && buffer[1] == 0x01)
			{
				strcpy( buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = CLICKSPQU;
				puts ("0x00 Ox01\t\t1 Track-Block (Bei Format 0 immer 1)");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x02)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = CLICKSPQU;
				puts ("0x00 0x02\t\t2 Track-Blcke");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x03)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_n = CLICKSPQU;
				puts ("0x00 0x03\t\t3 Track-Blcke");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x04)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = CLICKSPQU;
				puts ("0x00 0x04\t\t4 Track-Blcke");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x05)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = CLICKSPQU;
				puts ("0x00 0x05\t\t5 Track-Blcke");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x06)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = CLICKSPQU;
				puts ("0x00 0x06\t\t6 Track-Blcke");
			}
		break;

		/* Anzahl Schlge/Viertelnote*/
		case CLICKSPQU:
			if (buffer[0] == 0x00 && buffer[1] == 0x90)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				M = 144;
				puts("0x00 0x90\t\t144 Schlge/Viertelnote");
			}
			else
			if (buffer[0] == 0x00 && huffer[1] == 0xa0)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				puts ("0x00 0xa0\t\t160 Schlge/Viertelnote");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0xb0)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				puts ("0x00 0xB0\t\t176 Schlge/Vierteltiote");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0xe0)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				puts("0x00 0xC0\t\t192 Schlge/Viertelnote");
			}
		break;

		/* Lnge des Track-Blocks */
		case TRACKLEN:
			if (buffer[0] == 0x00 && buffer[1] == 0x00
			    && buffer[2] == 0x00 && buffer[3] == 0x0d)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				puts ("0x00 0x00 0x00 0x0d\t"
				      "Lnge des Track-Blocks 13 Bytes nachfolgend");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x00
			    && buffer[2] == 0x00 && buffer[3] == 0x0c)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				puts ("0x00 0x00 0x00 0x0e\t"
				      "Lnge des Track-Blocks 14 Bytes nachfolgend");
			}
			else
			if (buffer[0] == 0x00 && bulfer[1] == 0x00
			    && buffer[2] == 0x00 && buffer[3] == 0x0f)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				Puts("0x00 0x00 0x00 0x0f\t"
				     "Lnge des Track-Blocks 15 Bytes nachfolgend");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x00
			    && buffer[2] == 0x00 && buffer[3] == 0x10)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				puts("0x00 0x00 0x00 0x10\t"
				     "Lnge des Track-Blocks 16 Bytes nachfolgend");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x00
			    && buffer[2] == 0x00 && buffer[3] == 0x11)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				puts("0x00 0x00 0x00 0x11\t"
				     "Lnge des Track-Blocks 17 Bytes nachfolgend");
			}
			else
			if (buffer[0] == 0x00 && buffer[1] == 0x00
			    && buffcr[2] == 0x00 && buffer[3] == 0x12)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				puts ("0x00 0x00 0x00 0x12\t"
				      "Lnge des Track-Blocks 18 Bytes nachfolgend");
			}
			else
				if (buffer[0] == 0x00 && buffer[1] == 0x00
				    && buffer[2] == 0x00 && buffer[3] == 0x13)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = DELTATIME;
					puts ("0x00 0x00 0x00 0xl3\t"
					      "Lnge des Track-Blocks 19 Bytes nachfolgend");
				}
				else
				if (buffer[0] == 0x00 && buffer[1] == 0x00
				    && buffer[2] == 0x00 && buffer[3] == 0x14)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = DELTATIME;
					puts ("0x00 0x00 0x00 0xl4\t"
					      "Lnge des Track-Blocks 20 Bytes nachfolgend");
				}
				else
				if (buffer[0] == 0x00 && buffer[1] == 0x00
				    && buffer[2] == 0x00 && buffer[3] == 0x15)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = DELTATIME;
					puts ("0x00 0x00 0x00 0x15\t"
					      "Lnge des Track-Blocks 21 Bytes nachfolgend");
				}
				else
				if (buffer[0] == 0x00 && buffer[1] == 0x00
				    && buffer[2] == 0x00 && buffer[3] == 0x24)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = DELTATIME;
					puts ("0x00 0x00 0x00 0x24\t"
					      "Lnge des Track-Blocks 36 Bytes nachfolgend");
				}
			break;

			/* Delta-Time */
			case DELTATIME:
				if (buffer[0] == 0x00)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = MIDIEVENT;
					puts("0x00\tDelta-Time 0");
				}
				else
				if (buffer[0] == 0x01)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = MIDIEVENT;
					puts("0x01\tDelta-Time 1");
				}
				else
				if (buffer[0] == 0x02)
				{
					strcpy (buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = MIDIEVENT;
					puts ("0x02\tDelta-Time 2");
				}
				else
				if (buffer[0] == 0x64)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = MIDIEVENT;
					tondauer(100);
					puts("0x64\tDelta-Time 100");
				}
			break;
			/* MIDI-Events */
			case MIDIEVENT:
				if (buffer[0] == 0xc0)	/* Program-Change */
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = PRG_NR;
					k = 0x00;
					printf ("0xC0\tPROGRAM-CHANGE auf Kanal 1");
				}
				else
				if (buffer[0] == 0xc1)
				{
					strcpy (buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = PRG_NR;
					k = 0x01;
					printf ("0xC1\tPROGRAM-CHANGE auf Kanal 2");
				}
				else
				if (buffer[0] == 0xc2)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = PRG_NR;
					k = 0x02;
					printf ("0xC2\tPROGRAM-CHANGE auf Kanal 3");
				}
				/* Note-on
				else
				if (buffer[0] == 0x90)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x00;
					on_off = 0x90;
					printf ("0x90\tNOTE-ON auf Kanal 1");
				}
				else
				if (buffer[0] == 0x91)
				{
					strcpy (buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x01;
					on_off = 0x90;
					printf("0x91\tNOTE-ON auf Kanal 2");
				}
				else
				if (buffer[0] == 0x92)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x02;
					on_off = 0x90;
					printf ("0x92\tNOTE-ON auf Kanal 3");
				}
				/* Noten-off */
				else
				if (buffer[0] == 0x80)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x00;
					on_off = 0x80;
					printf ("0x80\tNOTE-OFF auf Kanal 1);
				}
				else
				if (buffer[0] == 0x81)
				{
					strcpy(buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x01;
					on_off = 0x80;
					printf ("0x81\tNOTE-OFF auf Kanal 2");
				}
				else
				if (buffer[0] == 0x82)
				{
					strcpy (buffer, LEER);	/* Puffer lschen */
					i = 0;
					d_fl = NOTE;
					k = 0x02;
					on_off = 0x80;
					printf ("0x82\tNOTE-OFF auf Kanal 3");
				}
			break;
			/* Programm-Nrn. */
			case PRG_NR:
			if (buffer[0] == 0x00)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x00);
				printf("\t0x00\tProgramm-Nr. 0\n");
			}
			else
			if (buffer[0] == 0x01)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x01);
				printf("\t0x01\tProgramm-Nr. 1 \n");
			}
			else
			if (buffer[0] == 0x02)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x02);
				printf("\t0x02\tProgramm-Nr. 2\n");
			}
			else
			if (buffer[0] == 0x0b)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x0b);
				printf("\t0x0B\tProgramm-Nr. ll\n");
			}
			else
			if (buffer[0] == 0x33)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x33);
				printf("\t0x33\(Programm-Nr. 51\n");
			}
			else
			if (buffer[0] == 0x3c)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				prg_change(0x3c);
				printf("\t0x3C\tProgramm-Nr. 60\n");
			}
		break;
		/* Ton-Nrn. */
		case NOTE:
			if (buffer[0] == 0x3e)
			{
				strcpy (buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = VELOCITY;
				th = 0x3e;
				printf ("\t\t0x3e\td1");
			}
			else
			if (buffer[0] == 0x42)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = VELOCITY;
				th = 0x42;
				printf("\t\t0x42\tfis1");
			}
			else
			if (buffer[0] == 0x45)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = VELOCITY;
				th = 0x45;
				printf("\t\t0x45\ta1");
			}
		break;

		case VELOCITY:
			if (buffer[0] == 0x00)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x00;
				printf("\t\10x00\tTon aus\n");
			}
			else
			if (buffer[0] == 0x10)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x10;
				printf("\t\t0x10\tppp\n");
			}
			else
			if (buffer[0] == 0x20)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x20;
				printf("\t\t0x20\tpp\n");
			}
			else
			if (buffer[0] == 0x30)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x30;
				printf("\t\t0x30\tp\n");
			}
			else
			if (buffer[0] == 0x40)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x40;
				printf("\t\t0x40\tmp\n");
			}
			else
			if (buffer[0] == 0x50)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x50;
				printf("\t\t0x50\tmf\n");
			}
			else
			if (buffer[0] == 0x60)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x60;
				printf("\t\t0x60\tf\n");
			}
			else
			if (buffer[0] == 0x70)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x70;
				printf("\t\t0x70\tff\n");
			}
			else
			if (buffer[0] == 0x7f)
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				dyn = 0x7f;
				printf("\t\t0x7f\tfff\n");
			}
			ton();
		break;
		/* Meta-Events
		case METAEVENT:
			if (buffer[0] == 0x2f)	/* Meta-Event Track-End */
			{
				strcpy(buffer, LEER);	/* Puffer lschen */
				i = 0;
				d_fl = DELTATIME;
				printf("\t0x2f\tTrack - End\n");
			}
		break;
		default:
		break;
	}						/* switch(d_fl) */
	return i;
}